From 86efc7a97a4a66f429e54f7eb49aa888ba9eace0 Mon Sep 17 00:00:00 2001
From: "Samantha N. Bueno" <sbueno+anaconda@redhat.com>
Date: Wed, 23 Mar 2016 22:52:32 -0400
Subject: [PATCH 4/7] Update examples and test cases for changes from isolating
 installer code.

---
 examples/factory.py          | 4 ++--
 examples/lvm.py              | 2 +-
 examples/lvm_cache.py        | 4 ++--
 examples/lvm_non_linear.py   | 4 ++--
 examples/partitioning.py     | 4 ++--
 tests/imagebackedtestcase.py | 4 ++--
 tests/populator_test.py      | 4 ++--
 7 files changed, 13 insertions(+), 13 deletions(-)

diff --git a/examples/factory.py b/examples/factory.py
index c580494..7c47746 100644
--- a/examples/factory.py
+++ b/examples/factory.py
@@ -9,9 +9,9 @@ b = blivet.Blivet()   # create an instance of Blivet (don't add system devices)
 
 # create two disk image files on which to create new devices
 disk1_file = create_sparse_tempfile("disk1", Size("100GiB"))
-b.config.disk_images["disk1"] = disk1_file
+b.disk_images["disk1"] = disk1_file
 disk2_file = create_sparse_tempfile("disk2", Size("100GiB"))
-b.config.disk_images["disk2"] = disk2_file
+b.disk_images["disk2"] = disk2_file
 
 b.reset()
 
diff --git a/examples/lvm.py b/examples/lvm.py
index 1c271f2..ac1f561 100644
--- a/examples/lvm.py
+++ b/examples/lvm.py
@@ -9,7 +9,7 @@ b = blivet.Blivet()   # create an instance of Blivet (don't add system devices)
 
 # create a disk image file on which to create new devices
 disk1_file = create_sparse_tempfile("disk1", Size("100GiB"))
-b.config.disk_images["disk1"] = disk1_file
+b.disk_images["disk1"] = disk1_file
 
 b.reset()
 
diff --git a/examples/lvm_cache.py b/examples/lvm_cache.py
index 6d49097..e8dd062 100644
--- a/examples/lvm_cache.py
+++ b/examples/lvm_cache.py
@@ -10,9 +10,9 @@ b = blivet.Blivet()   # create an instance of Blivet (don't add system devices)
 
 # create a disk image file on which to create new devices
 disk1_file = create_sparse_tempfile("disk1", Size("100GiB"))
-b.config.disk_images["disk1"] = disk1_file
+b.disk_images["disk1"] = disk1_file
 disk2_file = create_sparse_tempfile("disk2", Size("100GiB"))
-b.config.disk_images["disk2"] = disk2_file
+b.disk_images["disk2"] = disk2_file
 
 b.reset()
 
diff --git a/examples/lvm_non_linear.py b/examples/lvm_non_linear.py
index 186b523..08a484c 100644
--- a/examples/lvm_non_linear.py
+++ b/examples/lvm_non_linear.py
@@ -9,9 +9,9 @@ b = blivet.Blivet()   # create an instance of Blivet (don't add system devices)
 
 # create a disk image file on which to create new devices
 disk1_file = create_sparse_tempfile("disk1", Size("100GiB"))
-b.config.disk_images["disk1"] = disk1_file
+b.disk_images["disk1"] = disk1_file
 disk2_file = create_sparse_tempfile("disk2", Size("100GiB"))
-b.config.disk_images["disk2"] = disk2_file
+b.disk_images["disk2"] = disk2_file
 
 b.reset()
 
diff --git a/examples/partitioning.py b/examples/partitioning.py
index c002c2f..ee53fa8 100644
--- a/examples/partitioning.py
+++ b/examples/partitioning.py
@@ -9,9 +9,9 @@ b = blivet.Blivet()   # create an instance of Blivet (don't add system devices)
 
 # create two disk image files on which to create new devices
 disk1_file = create_sparse_tempfile("disk1", Size("100GiB"))
-b.config.disk_images["disk1"] = disk1_file
+b.disk_images["disk1"] = disk1_file
 disk2_file = create_sparse_tempfile("disk2", Size("100GiB"))
-b.config.disk_images["disk2"] = disk2_file
+b.disk_images["disk2"] = disk2_file
 
 b.reset()
 
diff --git a/tests/imagebackedtestcase.py b/tests/imagebackedtestcase.py
index 01e2929..caa1d61 100644
--- a/tests/imagebackedtestcase.py
+++ b/tests/imagebackedtestcase.py
@@ -44,7 +44,7 @@ class ImageBackedTestCase(unittest.TestCase):
         """
         for (name, size) in iter(self.disks.items()):
             path = util.create_sparse_tempfile(name, size)
-            self.blivet.config.disk_images[name] = path
+            self.blivet.disk_images[name] = path
 
         #
         # set up the disk images with a disklabel
@@ -104,7 +104,7 @@ class ImageBackedTestCase(unittest.TestCase):
         """ Clean up any resources that may have been set up for a test. """
         self.blivet.reset()
         self.blivet.devicetree.teardown_disk_images()
-        for fn in self.blivet.config.disk_images.values():
+        for fn in self.blivet.disk_images.values():
             if os.path.exists(fn):
                 os.unlink(fn)
 
diff --git a/tests/populator_test.py b/tests/populator_test.py
index 8975b0f..ccd4974 100644
--- a/tests/populator_test.py
+++ b/tests/populator_test.py
@@ -48,7 +48,7 @@ class setupDiskImagesNonZeroSizeTestCase(unittest.TestCase):
         # anaconda first configures disk images
         for (name, size) in iter(self.disks.items()):
             path = util.create_sparse_tempfile(name, size)
-            self.blivet.config.disk_images[name] = path
+            self.blivet.disk_images[name] = path
 
         # at this point the DMLinearDevice has correct size
         self.blivet.setup_disk_images()
@@ -67,7 +67,7 @@ class setupDiskImagesNonZeroSizeTestCase(unittest.TestCase):
     def tearDown(self):
         self.blivet.reset()
         self.blivet.devicetree.teardown_disk_images()
-        for fn in self.blivet.config.disk_images.values():
+        for fn in self.blivet.disk_images.values():
             if os.path.exists(fn):
                 os.unlink(fn)
 
-- 
2.4.3